#include <i2cmaster.h>  //Quelle: Peter Fleury
#define bereitPin 6 //Pluspol der Color-LED
#define scanPin 7  //Minuspol der Color-LED
#define tphPin 4
#define tplPin 5
#define bereichPin 8


 int syncPin = 12;
 int clockPin = 11;
 int dataPin = 2; // nur Port 0..5 möglich
 int lightVal[128]; //Zwischenspeicherung der Analogwerte
 unsigned long utime;
 int itime = 0;
 int capTime = 20; //Belichtungszeit standard 20ms
 String readString;
 int taktzeit = 7390; // 8333uSec ie 1/120th second

 void setup() //Startinitialisierung
 {
   pinMode (bereitPin, OUTPUT);
   pinMode (scanPin, OUTPUT);
   pinMode (tphPin, OUTPUT);
   pinMode (tplPin, OUTPUT);
   pinMode(clockPin, OUTPUT);
   pinMode(syncPin, OUTPUT);
   pinMode(bereichPin, INPUT);
 Serial.begin(9600); //9600 Baud
 	i2c_init(); //Initialise the i2c bus
	PORTC = (1 << PORTC4) | (1 << PORTC5);//enable pullups
 }

 void loop() //Hauptprogramm
 {
   
   digitalWrite (bereitPin, HIGH);  //rot leuchtet
   digitalWrite (scanPin, LOW);
   readString = "";
   int b=-1;
   while (Serial.available()) {
    delay(3);  //delay to allow buffer to fill 
    if (Serial.available() >0) {
      if(b==-1) b = Serial.read();
      else{
        char c = Serial.read();  //gets one byte from serial buffer
        readString += c; //makes the string readString
      }
    } 
   }
 if (b == 's') 
   {
   if(readString!="" && readString.toInt()>-1 && readString.toInt()<31000)
     capTime = readString.toInt(); 
     Serial.println("CT:"+String(capTime));
   digitalWrite (tphPin, LOW);  //rot leuchtet
   digitalWrite (tplPin, LOW);
   getLSR();  //Auslesen der Diodenzeile 
   delay(500);  //Verzögerung vor erneuter Auslesung
   }
  if (b =='t')
  { 
   digitalWrite (tphPin, HIGH);  //rot leuchtet
   digitalWrite (tplPin, LOW);
    getTemp();
 
  }
 }

 void getLSR()
 {   digitalWrite (bereitPin, LOW),
   digitalWrite( scanPin, HIGH);  //grün leuchtet
   
  pinMode(syncPin, OUTPUT);
  digitalWrite(syncPin, HIGH);
  digitalWrite(clockPin, HIGH);
  digitalWrite(syncPin, LOW);
  utime = micros();
  digitalWrite(clockPin, LOW);
  for (int j = 0; j < 128; j++)
    {
    digitalWrite(clockPin, HIGH);
    delayMicroseconds(capTime);
    digitalWrite(clockPin, LOW);
    }
 // delayMicroseconds(capTime);
  digitalWrite(syncPin, HIGH);
  digitalWrite(clockPin, HIGH);
  digitalWrite(syncPin, LOW);
  utime = micros() - utime;
  digitalWrite(clockPin, LOW);
  pinMode(bereichPin,INPUT);
  for (int j = 0; j < 128; j++)//Auslesen der Spannungswerte
   {
   //delayMicroseconds(capTime);
   lightVal[j] = analogRead(dataPin); //Zwischenwerte merken
   digitalWrite(clockPin, HIGH);
   digitalWrite(clockPin, LOW);
   } 
   if (digitalRead(bereichPin) == LOW) 
       {
           Serial.println("RN:V");
       }else{
           Serial.println("RN:IR");
       }
  for (int j = 0; j < 128; j++)
   {
     
    Serial.print(j);//Fortlaufende Diodennummer (Frequenz)
    Serial.print(" "); //Trennzeichen einfügen
    Serial.println(lightVal[j], DEC); //Ausgabe der Zwischenwerte Intensität

   itime = (int)utime;
     }  
   digitalWrite(bereitPin, HIGH); //rot leuchtet
   digitalWrite(scanPin, LOW);
 }

void getTemp()
{
    int dev = 0x5A<<1;
    int data_low = 0;
    int data_high = 0;
    int pec = 0;
    i2c_start_wait(dev+I2C_WRITE);
    i2c_write(0x07);
    
    // read
    i2c_rep_start(dev+I2C_READ);
    data_low = i2c_readAck(); //Read 1 byte and then send ack
    data_high = i2c_readAck(); //Read 1 byte and then send ack
    pec = i2c_readNak();
    i2c_stop();
    
    //This converts high and low bytes together and processes temperature, MSB is a error bit and is ignored for temps
    double tempFactor = 0.02; // 0.02 degrees per LSB (measurement resolution of the MLX90614)
    double tempData = 0x0000; // zero out the data
    int frac; // data past the decimal point
    
    // This masks off the error bit of the high byte, then moves it left 8 bits and adds the low byte.
    tempData = (double)(((data_high & 0x007F) << 8) + data_low);
    tempData = (tempData * tempFactor)-0.01;
    
    float celcius = tempData - 273.15;
  //  float fahrenheit = (celcius*1.8) + 32;

    Serial.println(celcius,DEC);
//    Serial.println(fahrenheit);

    delay(1000); // wait a second before printing again
     digitalWrite (tphPin, LOW);  //grün
     digitalWrite (tplPin, HIGH);

}
